package com.ruoyi.flowable.oa;

import org.flowable.bpmn.model.CallActivity;
import org.flowable.bpmn.model.ExtensionAttribute;
import org.flowable.bpmn.model.ExtensionElement;
import org.flowable.bpmn.model.IOParameter;
import org.flowable.engine.delegate.DelegateExecution;
import org.flowable.engine.delegate.ExecutionListener;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component("CallBudgetActivityExecutionListener")
public class CallBudgetActivityExecutionListener implements ExecutionListener {
    @Override
    public void notify(DelegateExecution delegateExecution) {
        CallActivity callActivity = (CallActivity)delegateExecution.getCurrentFlowElement();
        String initiator = null;
        Map<String, List<ExtensionElement>> extensionElements = callActivity.getExtensionElements();
        for(Map.Entry<String, List<ExtensionElement>> entry: extensionElements.entrySet()) {
            // 这一层读取的就是 button 类似的标签
            String attributeName = entry.getKey();
            List<ExtensionElement> attributeValueList = entry.getValue();
            if (attributeName.equals("budgetInitiator")) {
                for(ExtensionElement item: attributeValueList) {
                    // 处理 类似button  ExtensionElement 里面的属性
                    Map<String, List<ExtensionAttribute>> extensionElementAttributes = item.getAttributes();
                    for (Map.Entry<String, List<ExtensionAttribute>> tmpEntry : extensionElementAttributes.entrySet()) {
                        initiator = tmpEntry.getValue().get(0).getValue(); //  把子流程的发起人找到
                    }
                }
            }
        }
        List<IOParameter> ioParameterList = callActivity.getInParameters();
        for (IOParameter ioParameter: ioParameterList) {
            String source = ioParameter.getSource();
            if (source.equals("budgetInitiator")) {
                delegateExecution.setVariable(source, initiator); // 把子流程的发起人先给到父流程，然后用引擎的能力进行传递
            }
        }
    }
}
