package com.ruoyi.oa.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * cmc技术方案对象 cmc_technical
 * 
 * @author cmc
 * @date 2024-04-02
 */
public class CmcTechnical extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 项目id */
    private String technicalId;

    /** 项目id */
    @Excel(name = "项目id")
    private String projectId;

    /** 技术负责人 */
    @Excel(name = "技术负责人")
    private Long technicalDirector;

    /** 技术设计人 */
    @Excel(name = "技术设计人")
    private Long technicalDesigner;

    /** 技术安排人 */
    @Excel(name = "技术安排人")
    private Long technicalPlanner;

    /** 技术安排意见 */
    @Excel(name = "技术安排意见")
    private String technicalComment;

    /** 质量检查员 */
    @Excel(name = "质量检查员")
    private String qualityInspector;

    /** 技术安排时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "技术安排时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date technicalTime;

    public void setTechnicalId(String technicalId) 
    {
        this.technicalId = technicalId;
    }

    public String getTechnicalId() 
    {
        return technicalId;
    }
    public void setProjectId(String projectId) 
    {
        this.projectId = projectId;
    }

    public String getProjectId() 
    {
        return projectId;
    }
    public void setTechnicalDirector(Long technicalDirector) 
    {
        this.technicalDirector = technicalDirector;
    }

    public Long getTechnicalDirector() 
    {
        return technicalDirector;
    }
    public void setTechnicalDesigner(Long technicalDesigner) 
    {
        this.technicalDesigner = technicalDesigner;
    }

    public Long getTechnicalDesigner() 
    {
        return technicalDesigner;
    }
    public void setTechnicalPlanner(Long technicalPlanner) 
    {
        this.technicalPlanner = technicalPlanner;
    }

    public Long getTechnicalPlanner() 
    {
        return technicalPlanner;
    }
    public void setTechnicalComment(String technicalComment) 
    {
        this.technicalComment = technicalComment;
    }

    public String getTechnicalComment() 
    {
        return technicalComment;
    }
    public void setQualityInspector(String qualityInspector) 
    {
        this.qualityInspector = qualityInspector;
    }

    public String getQualityInspector() 
    {
        return qualityInspector;
    }
    public void setTechnicalTime(Date technicalTime) 
    {
        this.technicalTime = technicalTime;
    }

    public Date getTechnicalTime() 
    {
        return technicalTime;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("technicalId", getTechnicalId())
            .append("projectId", getProjectId())
            .append("technicalDirector", getTechnicalDirector())
            .append("technicalDesigner", getTechnicalDesigner())
            .append("technicalPlanner", getTechnicalPlanner())
            .append("technicalComment", getTechnicalComment())
            .append("qualityInspector", getQualityInspector())
            .append("technicalTime", getTechnicalTime())
            .toString();
    }
}
